Initial import of linux-libre deblob scripts from https://www.fsfla.org/svn/fsfla...
[librecmc/linux-deblob.git] / 2.6.39.1-libre / deblob-main
1 #! /bin/sh
2
3 # Copyright (C) 2008, 2009, 2010 Alexandre Oliva <lxoliva@fsfla.org>
4
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9
10 # This program is distributed in the hope that it will be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 # General Public License for more details.
14
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
18 # USA
19
20 # deblob.sh - prepare a linux-libre tarball out of a non-libre Linux
21 # tarball.  It expects the Linux release (mver, say 2.6.25) as the
22 # first argument, the libre sub-release (extra) as the second optional
23 # argument, and the patch release (sver, say .13) as an optional third
24 # argument.  mver and sver are pasted together to form kver.
25
26 # linux-$kver.tar.bz2 and deblob-$mver must exist in the current
27 # directory, and the line that sets kver and extra in deblob-$mver
28 # must match mver and extra.
29
30 # The resulting tarball is put in linux-$kver-libre$extra.tar.bz2, and
31 # an uncompressed xdelta that produces linux-$kver-libre$extra.tar out
32 # of linux-$kver.tar is created as linux-$kver-libre$extra.xdelta.
33 # This xdelta can be distributed to enable third parties to easily
34 # reconstruct the binary tarball starting out of sources downloaded
35 # from kernel.org, but without distributing non-Free Software
36 # yourself, because xdelta (unlike patches) is not reversible: the
37 # removed bits are not present in it at all.
38
39 # To enable you to check the differences between the tarballs, a patch
40 # file is generated in linux-$kver-libre$extra.patch.  This patch file
41 # contains the non-Free blobs, even though in reversed form, so its
42 # distribution is discouraged.
43
44 # At the end, the script attempts to generate a digital signature for
45 # the newly-created tarball.  This is the last thing the script does,
46 # so interrupting it at that point to skip the signing won't fail to
47 # do anything else.
48
49 # It is safe to interrupt the script at any other point.  When it gets
50 # a ^C (other than during signing), it starts cleaning up all of its
51 # temporary and output files.  If you insist, it may leave junk
52 # behind, and then it will refuse to run again before you clean it up
53 # by hand.  It takes extra care to avoid overwriting useful files.
54
55 # If deblob-$mver finds any unexpected situation, it will error out,
56 # and then deblob-main will quit.  Pass --force to deblob-main, before
57 # any other argument, for deblob-main to ignore any such situations.
58
59 case $1 in
60 --force) force=--force; shift;;
61 *) force=;;
62 esac
63
64 mver=$1 extra=$2 sver=$3
65 kver=$mver$sver libre=libre$extra
66 deblob= dir=`echo "$0" | sed 's,[^/]*$,,;s,^$,.,;s,/*$,,'`
67
68 if test ! -f linux-$kver.tar.bz2; then
69   echo linux-$kver.tar.bz2 does not exist >&2
70   exit 1
71 fi
72
73 if test -f deblob-$mver; then
74   deblob=deblob-$mver
75 elif test -f deblob; then
76   deblob=deblob
77 elif test -f $dir/deblob-$mver; then
78   cp $dir/deblob-$mver deblob
79   deblob=deblob
80 else
81   echo deblob does not exist >&2
82   exit 1
83 fi
84
85 x1="kver=$mver extra=$extra"
86 x2=`grep "^kver=[^ ]* extra=" $deblob`
87 if test "$x1" = "$x2"; then
88   :
89 else
90   echo deblob script does not match command-line arguments >&2
91   echo expected: $x1 >&2
92   echo found   : $x2 >&2
93   exit 1
94 fi
95
96 cleanup=
97
98 for f in \
99   linux-$kver-$libre.tar.bz2 \
100   linux-$kver-$libre.tar.bz2.asc \
101   linux-$kver-$libre.tar.bz2.sign \
102   linux-$kver-$libre.tar.lz \
103   linux-$kver-$libre.tar.lz.asc \
104   linux-$kver-$libre.tar.lz.sign \
105   linux-$kver.tar \
106   linux-$kver-$libre.tar \
107   linux-$kver-$libre.patch \
108   linux-$kver-$libre.log \
109   linux-$kver-$libre.xdelta \
110   linux-$kver-$libre.xdelta.asc \
111   linux-$kver-$libre.xdelta.sign \
112 ; do
113   if test -f $f; then
114     echo $f already exists >&2
115     exit 1
116   fi
117   cleanup="$cleanup $f"
118 done
119
120 for d in \
121   linux-$kver \
122   linux-$kver-$libre \
123   orig-linux-$kver \
124 ; do
125   if test -d $d; then
126     echo $d already exists >&2
127     exit 1
128   fi
129   cleanup="$cleanup $d"
130 done
131
132 if test -f $dir/deblob-$kver; then
133   if cmp $dir/deblob-$kver $deblob; then
134     :
135   else
136     echo $dir/deblob-$kver and $deblob are different >&2
137     exit 1
138   fi
139 fi
140
141 if test ! -f deblob-check; then
142   if test -f $dir/deblob-check; then
143     cp $dir/deblob-check deblob-check
144   fi
145 else
146   if test -f $dir/deblob-check; then
147     if cmp $dir/deblob-check deblob-check; then
148       :
149     else
150       echo $dir/deblob-check and deblob-check are different >&2
151       exit 1
152     fi
153   fi
154 fi
155
156 trap "status=$?; echo cleaning up...; rm -rf $cleanup; (exit $status); exit" 0 1 2 15
157
158 set -e
159
160 echo Uncompressing linux-$kver.tar.bz2 into linux-$kver.tar
161 rm -rf linux-$kver linux-$kver.tar
162 bunzip2 < linux-$kver.tar.bz2 > linux-$kver.tar
163
164 echo Extracting linux-$kver.tar into linux-$kver
165 tar -xf linux-$kver.tar
166 rm -rf linux-$kver-$libre linux-$kver-$libre.tar
167
168 echo Copying linux-$kver to linux-$kver-$libre
169 cp linux-$kver.tar linux-$kver-$libre.tar
170 cp -lR linux-$kver/. linux-$kver-$libre
171
172 rm -f linux-$kver-$libre.log linux-$kver-$libre.log.tmp
173 echo Deblobbing within linux-$kver-$libre, saving output to linux-$kver-$libre.log
174 # We can't just pipe deblob into tee, for then we fail to detect
175 # error conditions.  Use file renaming to tell whether we succeeded.
176 if (cd linux-$kver-$libre && /bin/sh ../$deblob $force) 2>&1; then
177   mv linux-$kver-$libre.log.tmp linux-$kver-$libre.log
178 fi | tee linux-$kver-$libre.log.tmp
179 if test ! -f linux-$kver-$libre.log; then
180   mv linux-$kver-$libre.log.tmp linux-$kver-$libre.log
181   echo $deblob failed, aborting >&2
182   exit 1
183 fi
184 rm -f linux-$kver-$libre.patch
185
186 # Do not copy these scripts for now, deblob-check regards itself as a blob.
187 # cp -p $0 $deblob deblob-check linux-$kver-$libre
188
189 echo Generating linux-$kver-$libre.patch
190 diff -druN linux-$kver linux-$kver-$libre > linux-$kver-$libre.patch || :
191
192 echo Removing removed or modified files from linux-$kver-$libre.tar
193 diff -rq linux-$kver linux-$kver-$libre |
194 sed -n "
195   s,^Only in \\(linux-$kver\\(/.*\\)\\?\\): \\(.*\\),\1/\3,p;
196   s,^Files \\(linux-$kver\\)/\\(.*\\) and \\1-$libre/\\2 differ,\\1/\\2,p;
197 " |
198 xargs tar --delete -f linux-$kver-$libre.tar
199
200 echo Adding modified or added files to linux-$kver-$libre.tar
201 rm -rf orig-linux-$kver
202 mv linux-$kver orig-linux-$kver
203 mv linux-$kver-$libre linux-$kver
204 diff -rq orig-linux-$kver linux-$kver |
205 sed -n "
206   s,^Files orig-\\(linux-$kver/.*\\) and \\1 differ,\\1,p;
207   s,^Only in \\(linux-$kver\\(/.*\\)\\?\\): \\(.*\\),\\1/\\3,p;
208 " |
209 xargs tar --append -f linux-$kver-$libre.tar
210
211 echo Wiping out extracted trees
212 rm -rf linux-$kver orig-linux-$kver
213
214 echo Creating xdelta between linux-$kver.tar and linux-$kver-$libre.tar
215 xdelta delta -0 linux-$kver.tar linux-$kver-$libre.tar linux-$kver-$libre.xdelta || : # xdelta returns nonzero on success
216
217 echo Compressing linux-$kver-$libre.tar and linux-$kver-$libre.xdelta
218 rm -f linux-$kver.tar
219 lzip -k9 linux-$kver-$libre.tar
220 bzip2 -9 linux-$kver-$libre.tar
221 if test -f linux-$kver-$libre.xdelta; then
222   lzip -k9 linux-$kver-$libre.xdelta
223   bzip2 -9 linux-$kver-$libre.xdelta
224 fi
225
226 trap "status=$?; (exit $status); exit" 0 1 2 15
227
228 echo Done except for signing, feel free to interrupt
229 for f in \
230   linux-$kver-$libre.tar.bz2 \
231   linux-$kver-$libre.tar.lz \
232   linux-$kver-$libre.xdelta.bz2 \
233   linux-$kver-$libre.xdelta.lz \
234 ; do
235   if test -f $f; then
236     gpg -a --detach-sign $f
237     mv $f.asc $f.sign
238   fi
239 done
240
241 echo All set, please review linux-$kver-$libre.patch
242
243 exit 0